;;; -*- lexical-binding: t -*-
(require 'cl-lib)

(defconst filter-biglist0 (number-sequence 0 1000))
(defconst filter-biglist1 (number-sequence 0 10000))
(defconst filter-biglist2 (number-sequence 0 100000))
(defconst filter-biglist3 (number-sequence 0 1000000))
(defconst filter-biglist4 (number-sequence 0 10000000))

(defun filter-by-dolist+push+nreverse (list)
  (let ((result nil))
    (dolist (num list)
      (when (cl-evenp num)
        (push num result)))
    (nreverse result)))

(defun filter-by-dolist+push (list)
  (let ((result nil))
    (dolist (num list)
      (when (cl-evenp num)
        (push num result)))
    result))

(defun filter-by-cl-delete-if (list)
  (cl-delete-if #'cl-evenp list))

(progn
  (message "dolist+push 1000")
  (benchmark 1 '(filter-by-dolist+push filter-biglist0))
  (message "dolist+push 10000")
  (benchmark 1 '(filter-by-dolist+push filter-biglist1))
  (message "dolist+push 100000")
  (benchmark 1 '(filter-by-dolist+push filter-biglist2))
  (message "dolist+push 1000000")
  (benchmark 1 '(filter-by-dolist+push filter-biglist3)))

(progn
  (message "dolist+push+nreverse 1000")
  (benchmark 1 '(filter-by-dolist+push+nreverse filter-biglist0))
  (message "dolist+push+nreverse 10000")
  (benchmark 1 '(filter-by-dolist+push+nreverse filter-biglist1))
  (message "dolist+push+nreverse 100000")
  (benchmark 1 '(filter-by-dolist+push+nreverse filter-biglist2))
  (message "dolist+push+nreverse 1000000")
  (benchmark 1 '(filter-by-dolist+push+nreverse filter-biglist3)))

(progn
  (message "cl-delete-if 1000")
  (benchmark 1 '(filter-by-cl-delete-if filter-biglist0))
  (message "cl-delete-if 10000")
  (benchmark 1 '(filter-by-cl-delete-if filter-biglist1))
  (message "cl-delete-if 100000")
  (benchmark 1 '(filter-by-cl-delete-if filter-biglist2))
  (message "cl-delete-if 1000000")
  (benchmark 1 '(filter-by-cl-delete-if filter-biglist3)))
